<?php
class Settings_page
{
    public  $options;

    public function __construct()
    {
        $this->options = get_option( 'options_design_awards' );
        $this->add_options();
        $this->register_fields();
    }

    public function add_options()
    {
        add_options_page('options_design_awards', PLUGINS_NAME, 'administrator', __FILE__, array($this, 'display_settings_page'));
    }

    public function display_settings_page()
    {
       echo "<div class='icon'><br/></div>";
       wp_enqueue_script("fabr_colorpicker");
       wp_enqueue_script("deleteData");
       wp_localize_script('deleteData', 'ajax_del_var', array(
            'url' => admin_url('admin-ajax.php'),
            'nonce' => "q33Y!J<aGjl3(0ar"
        ));
       
       wp_enqueue_style( 'colorpicker_css');
       wp_enqueue_style( 'aw_options_page_style');

       echo "<h1>".PLUGINS_NAME." Settings</h1>";
      ?>
      <p class="clear"></p>
      <form method="post" action="options.php" enctype="multipart/form-data" >
      <?php settings_fields( 'options_design_awards' ); ?>
      <?php do_settings_sections(__FILE__); ?>
      <p>
          <input type="submit" name="submit" value="Save Changes" class="button-primary">
          <input type="button" class="red-gradient" id="show-reset-database" value="Show Reset Database Form">
      </p>
      </form>

        <div class='reset-box'>
            <div>
                <p></p>
                <input id="design_awards_delete_custom_database" type="button" class="btn btn-large btn-danger centered" value="Reset Database" />
                <span>This button will erase all custom posts and the rating database! <strong>This is not reversible!</strong></span>
            </div>
        </div>
        <script type="text/javascript" >
            jQuery(document).ready(function() {
                jQuery('#colorpicker-bg').farbtastic('#color-bg');
                jQuery('#colorpicker-average').farbtastic('#color-average');
                jQuery('#colorpicker-active').farbtastic('#color-active');

                jQuery('.reset-box').css({ display: 'none'});
                jQuery('#show-reset-database').click(function(){
                    jQuery('.reset-box').slideToggle(300);
                });

                jQuery('.form-table').css({
                    position : 'relative'
                });
               jQuery('.form-table')
                       .eq(2).children('tbody')
                       .children('tr')
                       .eq(2)
                       .css({ height : 60})
                       .children('td')
                       .children('div')
                       .css({ position: 'absolute', bottom : 10, left: 10});

                jQuery('.form-table')
                        .eq(2)
                        .children('tbody')
                        .children('tr')
                        .children('th')
                        .eq(2)
                        .css({ opacity: 0 });
                jQuery('.form-table')
                        .eq(2)
                        .children('tbody')
                        .children('tr')
                        .children('th')
                        .eq(1)
                        .css({ fontSize: 15, fontWeight: 'bold' });

                jQuery('h3').eq(3).css({marginBottom : 50});

            });

        </script>
      <?php
    }

    public function register_fields()
    {
        register_setting( 'options_design_awards',  'options_design_awards', array( $this, 'validate_options'));

        add_settings_section('basic_settings', 'Basic settings', array($this, 'basic_section_cb'), __FILE__);
        add_settings_section('rating_settings', 'Rating settings', array($this, 'rating_section_cb'), __FILE__);
        add_settings_section('rating_settings', 'Rating settings', array($this, 'rating_section_cb'), __FILE__);
        add_settings_section('icon_settings', 'Icon settings', array($this, 'icon_section_cb'), __FILE__);
        add_settings_section('color_settings', 'Color settings', array($this, 'color_section_cb'), __FILE__);

        //Basic Settings
        add_settings_field('image_width', 'Image width', array($this,'image_width'), __FILE__, 'basic_settings');
        add_settings_field('image_height', 'Image height', array($this,'image_height'), __FILE__, 'basic_settings');
        add_settings_field('thumbnail_factor', 'Thumbnail Shrink Factor', array($this,'thumbnail_factor'), __FILE__, 'basic_settings');
        add_settings_field('image_type', 'Thumbnail image type', array($this,'image_type'), __FILE__, 'basic_settings');
        add_settings_field('post_status', 'Post status', array($this,'post_status'), __FILE__, 'basic_settings');
        add_settings_field('post_default_taxonomy_term', 'Default Category', array($this,'post_default_taxonomy_term'), __FILE__, 'basic_settings');
        add_settings_field('plugin_lang', 'Language', array($this,'plugin_lang'), __FILE__, 'basic_settings');
        add_settings_field('website_category', 'Website category', array($this,'website_category'), __FILE__, 'basic_settings');

        //Rating Settings
        add_settings_field('number_of_stars', 'Number of stars', array($this,'number_of_stars'), __FILE__, 'rating_settings');
        add_settings_field('max_rating', 'Max rating', array($this,'max_rating'), __FILE__, 'rating_settings');

        //Icon Settings
        add_settings_field('default_rating_images', 'Default rating images', array($this,'default_rating_images'), __FILE__, 'icon_settings');
        add_settings_field('change_image', 'Use custom image', array($this,'change_image'), __FILE__, 'icon_settings');
        add_settings_field('custom_rating_image', 'Custom rating Image', array($this,'custom_rating_image'), __FILE__, 'icon_settings');


        //Color Settings
        add_settings_field('stars_background_color', 'Stars background color', array($this,'stars_background_color'), __FILE__, 'color_settings');
        add_settings_field('average_rating_color', 'Average rating color', array($this,'average_rating_color'), __FILE__, 'color_settings');
        add_settings_field('active_rating_color', 'Active rating color', array($this,'active_rating_color'), __FILE__, 'color_settings');

    }

    public function validate_options($options)
    {
        $max_stars = 10;
        $default = get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars/stars.png';
        
        $thumbnail_factor = 100;
        if(!is_numeric($options['thumbnail_factor']) || $options['thumbnail_factor']==0) $options['thumbnail_factor'] = 100;
        if(!is_numeric($options['image_width']) || $options['image_width']<50) $options['image_width'] = 300;
        if(!is_numeric($options['image_height']) || $options['image_height']<50) $options['image_height'] = 200;
        
        $thumbnail_factor = round((100/$options['thumbnail_factor']),2);
        $options['thumbnail_factor'] = $thumbnail_factor;
        
        $options['image_width'] = round($options['image_width']);
        $options['image_height'] = round($options['image_height']);

        $max_stars =  round($options['image_width']/$options['thumbnail_factor']);
        $max_stars = round($max_stars/23)-1;       

        if(!($options['number_of_stars']<= $max_stars)
            || !($options['number_of_stars']>=3)
            || !is_numeric($options['number_of_stars'])):

            $options['number_of_stars'] = $max_stars;
        endif;

        if(!empty( $_FILES['custom_rating_image']['tmp_name']))
        {
            list($width, $height) = getimagesize($_FILES['custom_rating_image']['tmp_name']);

            if($width == 23 && $height == 20):
                $override = array('test_form' => false);
                $file = wp_handle_upload($_FILES['custom_rating_image'], $override);
                $options['custom_rating_image'] = $file['url'];
            endif;
        }
        else
        {
            $options['custom_rating_image'] = isset($this->options['custom_rating_image'])?
                $this->options['custom_rating_image']: $default;

            if(isset($options['default_rating_images']) && !isset($options['change_image']) ):
                $options['custom_rating_image'] = $options['default_rating_images'];
            endif;
        }

        return $options;
    }

    public function basic_section_cb()
    {

    }

    public function rating_section_cb()
    {

    }

    public function icon_section_cb()
    {

    }

    public function color_section_cb()
    {

    }

    //Basic Section Setting functions
    public function image_width()
    {
        $image_width = 0;
        if(!empty($this->options) && isset($this->options['image_width']))  $image_width  = $this->options['image_width'];
        echo "<input name='options_design_awards[image_width]' type='number' value='$image_width' />";
    }
    public function image_height()
    {
        $image_height = 0;
        if(!empty($this->options) && isset($this->options['image_height']))  $image_height  = $this->options['image_height'];
        echo "<input name='options_design_awards[image_height]' type='number' value='$image_height' />";
    }
    public function thumbnail_factor()
    {
        $thumbnail_factor = 100;
        if(!empty($this->options) && isset($this->options['thumbnail_factor']))  $thumbnail_factor  = $this->options['thumbnail_factor'];
        $thumbnail_factor = round(100/$thumbnail_factor);
        echo "<input name='options_design_awards[thumbnail_factor]' type='number' max='300' value='$thumbnail_factor' />%";
    }
    public function image_type()
    {
        $image_type = 'png';
        $types = array('png', 'jpeg', 'gif', 'all types');
        if(!empty($this->options) && isset($this->options['image_type']))  $image_type  = $this->options['image_type'];

        echo "<select name='options_design_awards[image_type]'>";
        foreach ($types as $type):
            $selected = ($image_type == $type ) ? " selected='selected' " : "";
            if($type == 'all types'):
                $selected =($image_type == '*')? " selected='selected' " : "";
                echo "<option value='*' $selected >$type</option>";
            else:
                echo "<option value='$type' $selected >$type</option>";
            endif;
        endforeach;
        echo "</select>";

    }

    public function post_status()
    {
        $post_status = 'pending';
        $types = array('publish', 'draft', 'pending');
        if(!empty($this->options) && isset($this->options['post_status']))  $post_status  = $this->options['post_status'];

        echo "<select name='options_design_awards[post_status]'>";
        foreach ($types as $type):
            $selected = ($post_status == $type ) ? " selected='selected' " : "";
                echo "<option value='$type' $selected >$type</option>";

        endforeach;
        echo "</select>";
    }

    public function  post_default_taxonomy_term()
    {
        global $wpdb;

        $default_category = false;
        if(!empty($this->options) && isset($this->options['default_category']))  $default_category  = $this->options['default_category'];

        $table_taxonomy = $wpdb->prefix . 'term_taxonomy';
        $table_terms = $wpdb->prefix . 'terms';

        $term_id_array = $wpdb->get_results("select term_id from $table_taxonomy where taxonomy = 'Participants'");
        $terms_array = $wpdb->get_results("select * from $table_terms ");
        $selected = array();
        $count =0;
        foreach($term_id_array as $key => $id)
        {
            $term_id_array[$key] = $id->term_id;
        }
        foreach($terms_array as $key => $value)
        {
           if(in_array($value->term_id,$term_id_array )):
               $selected[$count++] = $value;
           endif;
        }

        ?>
        <?php
        echo "<select name='options_design_awards[default_category]'>";
        foreach($selected as $term):
            $selected = '';
            if($default_category!=false && $term->term_id == $default_category) $selected = 'selected="selected"';
            echo "<option value='$term->term_id' $selected>".ucwords($term->name)."</option>";
        endforeach;
        echo "</select>";
    }

    public function plugin_lang()
    {
        $selected_lang = 'english';
        if(!empty($this->options) && isset($this->options['plugin_lang']))  $selected_lang  = $this->options['plugin_lang'];

        $langs = scandir(PLUGIN_ROOT_FOLDER.'/language');
        $forbitten = array('.','..','index.html');
        echo "<select name='options_design_awards[plugin_lang]'>";
        foreach ($langs as $lang):
            if(in_array($lang,$forbitten)) continue;
            $lang = str_replace('.php','',$lang);
            $selected = ($selected_lang == $lang)? 'selected="selected"' : '';
            echo "<option value='$lang' $selected >$lang</option>";
        endforeach;
        echo "</select>";
    }

    public function  website_category()
    {
        $website_category = '';
        if(!empty($this->options) && isset($this->options['website_category']))  $website_category = $this->options['website_category'];
        echo "<textarea name='options_design_awards[website_category]' cols='40' rows='3' type='text' >$website_category</textarea>";
    }


    //Rating Section functions
    public function max_rating()
    {
        $max_rating = 10;
        if(!empty($this->options) && isset($this->options['max_rating']))  $max_rating  = $this->options['max_rating'];
        echo "<input name='options_design_awards[max_rating]' type='number' value='$max_rating' />";
    }

    public function custom_rating_image()
    {
        $custom_rating_image = get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars_1.png';

        if(!empty($this->options)
            && isset($this->options['custom_rating_image'])):
            $custom_rating_image = $this->options['custom_rating_image'];
        endif;
        ?>
            <div id="upload-custom-image-div">
                <input type="text" value="<?php  echo $custom_rating_image; ?>" onclick="this.select()">

                <label for="upload-custom-image" class="upload-button" >Upload a custom Image</label>
                <input id="upload-custom-image" style="display: none;" type='file' name='custom_rating_image' />
                <div style="font-weight: bold; color: #4c4cc9;">Image must be 23x20 px</div>
            </div>
        <?php

    }

    public function default_rating_images()
    {
        $default = get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars.png';
        $custom_rating_image = get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars_1.png';

        if(!empty($this->options)):
            if(isset($this->options['default_rating_images'])) $default = $this->options['default_rating_images'];
            if(isset($this->options['custom_rating_image'])) $custom_rating_image = $this->options['custom_rating_image'];
        endif;

        $bgcolor = isset($this->options['stars_background_color'])?$this->options['stars_background_color'] : '#f04040';
        $avcolor = isset($this->options['average_rating_color'])?$this->options['average_rating_color'] : '#ff9900';
        $accolor = isset($this->options['active_rating_color'])?$this->options['active_rating_color'] : '#dd4918';
        ?>
        <style type="text/css">

            .admin_awards_rating_image .image:nth-child(1){ background: <?php echo $bgcolor; ?>; }
            .admin_awards_rating_image .image:nth-child(2){ background: <?php echo $avcolor; ?>; }
            .admin_awards_rating_image .image:nth-child(3){ background: <?php echo $accolor; ?>; }

        </style>
        <?php


        $default_rating_images = array(
            'default' => get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars/stars.png',
            'gear' => get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars/gear.png',
            'fire' => get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars/fire.png',
            'medal' => get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars/medal.png',
            'medal outline' => get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars/medal_outline.png',
            'medal of honor' => get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars/medal_of_honor.png',
            'medal modern' => get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars/medal_modern.png',
            'award' => get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars/award.png',
            'cup' => get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars/cup.png',
            'molecule' => get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars/molecule.png',
            'badge' => get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars/badge.png',
            'asteroid' => get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars/asteroid.png',
            'arrow' => get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars/arrow.png',
            'heart' => get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars/heart.png',
            'butterfly' => get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars/butterfly.png',
            'flower' => get_bloginfo('url').'/wp-content/plugins/design_awards/js/stars/flower.png'
        );

        ?>

        <select class='default-rating-images'  name="options_design_awards[default_rating_images]">
                <?php foreach($default_rating_images as $name => $image): ?>
                    <?php $selected = ($default == $image)? 'selected="selected"' : ''; ?>
                    <option value="<?php echo $image ?>" <?php echo $selected; ?> ><?php echo $name ?></option>
                <?php endforeach; ?>
        </select>
        <div class="admin_awards_rating_image">
            <div class="image" id="bg-color-div"><img src="<?php  echo $custom_rating_image; ?>" /></div>
            <div class="image" id="av-color-div"><img src="<?php  echo $custom_rating_image; ?>" /></div>
            <div class="image" id="ac=color-div"><img src="<?php  echo $custom_rating_image; ?>" /></div>
        </div>
        <?php

    }

    public function change_image()
    {
        $checked = ( isset($this->options) && isset($this->options['change_image']))? 'checked="checked"' : '';
        ?>

        <style type="text/css">
            .you_must_check_to_change + div{ display: none; padding: 10px; position: absolute; left: 30px; top: -50px; z-index: 2; background: #fff; border: 1px solid #aaa;}
            .you_must_check_to_change:hover + div { display: block;}
        </style>
        <div class="you_must_check_to_change-class" style="position: relative">
        <input class="you_must_check_to_change" <?php echo $checked;  ?> type="checkbox" name="options_design_awards[change_image]"/>
        <div  style="width: 200px; font-style: italic; font-size: 10px;">
            If you want to choose one of the defaults you must check it! However it will overwrite the custom image, if you have one already set!</div>
        </div>
        <?php
    }

    public function number_of_stars()
    {
        $number_of_stars = 10;
        if(!empty($this->options) && isset($this->options['number_of_stars']))  $number_of_stars  = $this->options['number_of_stars'];
        echo "<input name='options_design_awards[number_of_stars]' type='number' value='$number_of_stars' />";
    }

    public function stars_background_color()
    {
        $color = '#000000';
        if(!empty($this->options) && isset($this->options['stars_background_color'])):
            $color  = $this->options['stars_background_color'];
        endif;
         ?>
            <input type="text" id="color-bg" style="float: left;" name='options_design_awards[stars_background_color]' value="<?php echo $color; ?>" />
            <div id="colorpicker-bg" style="float: left; position: relative; top: -60px; left: 200px;"></div>
        <?php
    }

    public function average_rating_color()
    {
        $color = '#ff9900';
        if(!empty($this->options) && isset($this->options['average_rating_color'])):
            $color  = $this->options['average_rating_color'];
        endif;
         ?>
            <input type="text" id="color-average" style="float: left;" name="options_design_awards[average_rating_color]" value="<?php echo $color; ?>" />
            <div id="colorpicker-average" style="float: left; position: relative; top: -60px; left: 200px;"></div>
        <?php
    }

    public function active_rating_color()
    {
        $color = '#dd4918';
        if(!empty($this->options) && isset($this->options['active_rating_color'])):
            $color  = $this->options['active_rating_color'];
        endif;
         ?>
            <input type="text" id="color-active" style="float: left;" name="options_design_awards[active_rating_color]" value="<?php echo $color; ?>" />
            <div id="colorpicker-active" style="float: left; position: relative; top: -60px; left: 200px;"></div>
        <?php
    }
}

?>