<?php


class Awards_widget extends WP_Widget
{
    public function __construct()
    {
        $params = array(
            'name' => 'Awards Widget',
            'description' => 'Displays a category of Participants'
        );
       parent::__construct('awards_widget','', $params );
    }

    public function form($instance)
    {

        extract($instance);        
        
        ?>               
            <p>
                <label for="<?php echo $this->get_field_id('header'); ?>">Header:</label>
                <input
                        type="text"
                        class="widefat"
                        id="<?php echo $this->get_field_id('header'); ?>"
                        name="<?php echo $this->get_field_name('header'); ?>"
                        value="<?php if(isset($header)) echo esc_attr($header); ?>"
                        />
            </p>
            <p>
                <label for="<?php echo $this->get_field_id('category_slug'); ?>">Category Id:</label>
                  <input
                        type="number"
                        class="widefat"
                        id="<?php echo $this->get_field_id('category_id'); ?>"
                        name="<?php echo $this->get_field_name('category_id'); ?>"
                        value="<?php if(isset($category_id)) echo esc_attr($category_id); ?>"
                        />
            </p>
            <p>
                <label for="<?php echo $this->get_field_id('category_id'); ?>">Rating:</label>

                <?php
                global $wpdb, $custom_post;
                $post_type = $custom_post['post_id'];
                $related = $wpdb->prefix . 'posts';
                $offset = isset($displays)? esc_attr($displays) : 5;
                $post_count = $wpdb->query("SELECT * FROM $related where post_type = '$post_type' and post_status = 'publish' ");

                ?>
                <select
                    class="widefat"
                    id="<?php echo $this->get_field_id('rating'); ?>"
                    name="<?php echo $this->get_field_name('rating'); ?>"
                        >
                    <?php for($i =0; $i<$post_count; $i+=$offset): ?>
                    <?php $selected = (isset($rating) && $rating == $i)? 'selected="selected"' : '';
                    if($post_count-1 == $i) break;
                    ?>
                    <option value="<?php echo $i; ?>" <?php echo $selected; ?> ><?php
                        $start = $i + 1;
                        $end = $i+$offset;
                        echo "$start - $end";
                        ?></option>
                    <?php endfor; ?>
                </select>
            </p>
            <p>
                <label for="<?php echo $this->get_field_id('displays'); ?>">Number of displays:</label>
                <input
                        type="number"
                        class="widefat"
                        id="<?php echo $this->get_field_id('displays'); ?>"
                        name="<?php echo $this->get_field_name('displays'); ?>"
                        value="<?php if(isset($displays)) echo esc_attr($displays); ?>"
                        />
            </p>
        <?php

    }

    public function widget($args, $instance)
    {
        global $wpdb, $custom_post;

        extract($args);
        extract($instance);
        $counter = 0;
        $offset = isset($rating)? $rating: 0;
        $rating_table = $wpdb->prefix . DATABASE_TABLE_NAME;

        //Get the array of ids for choosen posts
        $results = $wpdb->get_results("SELECT post_id FROM $rating_table order by (rating/votes_count) DESC", ARRAY_N);
        $results = array_slice($results, $offset);
        $temp = array();
        for($i=0; $i<count($results); $i++):
            $temp[] = $results[$i][0];
        endfor;
        $results = $temp;

        echo $before_widget;
        echo $before_title.$header.$after_title;
        echo "<ul>";
        $loop = new WP_Query(
            array(
                'post_type' => $custom_post['post_id'],
            )
        );

        while($loop->have_posts())
        {
            $loop->the_post();
            $id = get_the_ID();
            $title = get_post_meta($id,'kt_website_title');
            $link = get_permalink();

            //Table with post/category assignments
            $related = $wpdb->prefix . 'term_relationships';

            //Check if the post id is in Category
            $stats = $wpdb->query("SELECT * FROM $related where object_id = $id and term_taxonomy_id = $category_id");

            if($stats==false || !in_array( $id, $results)) continue;
            if($counter++ == $displays) break;

            echo "<li><a href='$link'>$title[0]</a></li>";

        }

        echo "</ul>";
        echo $after_widget;
    }
}


?>