/************************************************************************
 *************************************************************************
 @Name :       	jRating - jQuery Plugin
 @Revison :    	3.0
 @Date : 		28/01/2013
 @Author:     	 ALPIXEL - (www.myjqueryplugins.com - www.alpixel.fr)
 @License :		 Open Source - MIT License : http://www.opensource.org/licenses/mit-license.php

 **************************************************************************
 *************************************************************************/
jQuery(document).ready(function($) {
    $.fn.jRating = function(op) {
        var defaults = {
            /** String vars **/
            bigStarsPath: ajax_var.image_rating, // path of the icon stars.png
            smallStarsPath: 'wp-content/plugins/design_awards/js/small.png', // path of the icon small.png
            phpPath: '.', // path of the php file jRating.php
            type: 'big', // can be set to 'small' or 'big'

            /** Boolean vars **/
            step:false, // if true,  mouseover binded star by star,
            isDisabled:false,
            showRateInfo: true,
            canRateAgain : false,

            /** Integer vars **/
            length: ajax_var.number_of_stars, // number of star to display
            decimalLength : 0, // number of decimals.. Max 3, but you can complete the function 'getNote'
            rateMax : ajax_var.max_rating, // maximal rate - integer from 0 to 9999 (or more)
            rateInfosX : -30, // relative position in X axis of the info box when mouseover
            rateInfosY : -40, // relative position in Y axis of the info box when mouseover
            nbRates : 1,

            /** Functions **/
            onSuccess : null,
            onError : null
        };

        if(this.length>0)
            return this.each(function() {
                /*vars*/
                var opts = $.extend(defaults, op),
                    newWidth = 0,
                    starWidth = 0,
                    starHeight = 0,
                    bgPath = '',
                    hasRated = false,
                    globalWidth = 0,
                    nbOfRates = opts.nbRates;

                if($(this).hasClass('jDisabled') || opts.isDisabled)
                    var jDisabled = true;
                else
                    var jDisabled = false;

                getStarWidth();
                $(this).height(starHeight);

                var average = parseFloat($(this).attr('data-average')), // get the average of all rates
                    idBox = parseInt($(this).attr('data-id')), // get the id of the box
                    votes = parseInt($(this).attr('data-votes')),
                    rating = parseInt($(this).attr('data-rating')),
                    widthRatingContainer = starWidth*opts.length, // Width of the Container
                    widthColor = average/opts.rateMax*widthRatingContainer, // Width of the color Container

                    quotient =
                        $('<div>',
                            {
                                'class' : 'jRatingColor',
                                css:{
                                    width:widthColor
                                }
                            }).appendTo($(this)),

                    average =
                        $('<div>',
                            {
                                'class' : 'jRatingAverage',
                                css:{
                                    width:0,
                                    top:- starHeight
                                }
                            }).appendTo($(this)),

                    jstar =
                        $('<div>',
                            {
                                'class' : 'jStar',
                                css:{
                                    width:widthRatingContainer,
                                    height:starHeight,
                                    top:- (starHeight*2),
                                    background: 'url('+bgPath+') repeat-x'
                                }
                            }).appendTo($(this));


                $(this).css({width: widthRatingContainer,overflow:'hidden',zIndex:1,position:'relative'});

                if(!jDisabled)
                    $(this).unbind().bind({
                        mouseenter : function(e){
                            var realOffsetLeft = findRealLeft(this);
                            var relativeX = e.pageX - realOffsetLeft;
                            if (opts.showRateInfo)
                                var tooltip =
                                    $('<p>',{
                                        'class' : 'jRatingInfos',
                                        html : getNote(relativeX)+' <span class="maxRate">/ '+opts.rateMax+'</span>',
                                        css : {
                                            top: (e.pageY + opts.rateInfosY),
                                            left: (e.pageX + opts.rateInfosX)
                                        }
                                    }).appendTo('body').show();
                        },
                        mouseover : function(e){
                            $(this).css('cursor','pointer');
                        },
                        mouseout : function(){
                            $(this).css('cursor','default');
                            if(hasRated) average.width(globalWidth);
                            else average.width(0);
                        },
                        mousemove : function(e){
                            var realOffsetLeft = findRealLeft(this);
                            var relativeX = e.pageX - realOffsetLeft;
                            if(opts.step) newWidth = Math.floor(relativeX/starWidth)*starWidth + starWidth;
                            else newWidth = relativeX;
                            average.width(newWidth);
                            if (opts.showRateInfo)
                                $("p.jRatingInfos")
                                    .css({
                                        left: (e.pageX + opts.rateInfosX)
                                    })
                                    .html(getNote(newWidth) +' <span class="maxRate">/ '+opts.rateMax+'</span>');
                        },
                        mouseleave : function(){
                            $("p.jRatingInfos").remove();
                        },
                        click : function(e){
                            var element = this;

                            /*set vars*/
                            hasRated = true;
                            globalWidth = newWidth;
                            nbOfRates--;

                            if(!opts.canRateAgain || parseInt(nbOfRates) <= 0) $(this).unbind().css('cursor','default').addClass('jDisabled');

                            if (opts.showRateInfo) $("p.jRatingInfos").fadeOut('fast',function(){$(this).remove();});
                            e.preventDefault();
                            var rate = getNote(newWidth);
                            average.width(newWidth);
                            
                            db = false;
                            
                            if(window.openDatabase){
	                            var db = openDatabase('aw_design_awards', 1, 'aw_design_awards', 10000000);
	
	                            if (db) {
	                                var host1 = window.location.host;
	                                db.transaction(function (transaction) {
	                                    transaction.executeSql("create table if not exists 'design_awards_data'( 'postID' integer not null,'site' text not null)");
	                                    transaction.executeSql("insert into design_awards_data (postID, site) values (" + idBox + ", '" + host1 + "')");
	                                });
	                            }
                            }
                            //If db doesn't work, make use of store.js
                            if(store){
                            	daw = store.get('daw_'); 
	                            if( daw == undefined){
	                            	 daw = Array();
	                            }                  
	                            else if( typeof(daw) == 'string' && typeof(JSON.parse(daw)) == 'object'){
	                            	daw = JSON.parse(daw);
	                            }
	                           
	                            daw.push(idBox);
	                            daw = JSON.stringify(daw);
	                            store.set('daw_', daw);
                            }
                            else{
                            	console.log('store not working');
                            }
                            
                            // Ajax call
                            jQuery.ajax({
                                type: "post",
                                url: ajax_var.url,
                                data: "action=site_rating&nonce=" + ajax_var.nonce + "&post_rate=" + rate + "&post_id=" + idBox,
                                success: function () {
                                    
                                    rating = rating + rate;
                                    votes = votes + 1;
                                    rate = Math.round((rating / votes) * 100) / 100;
                                    $(element).parent('div').siblings('.rating-stats').html(rate + '/' + votes);
                                }
                            });
                        }
                    });

                function getNote(relativeX) {
                    var noteBrut = parseFloat((relativeX*100/widthRatingContainer)*opts.rateMax/100);
                    switch(opts.decimalLength) {
                        case 1 :
                            var note = Math.round(noteBrut*10)/10;
                            break;
                        case 2 :
                            var note = Math.round(noteBrut*100)/100;
                            break;
                        case 3 :
                            var note = Math.round(noteBrut*1000)/1000;
                            break;
                        default :
                            var note = Math.round(noteBrut*1)/1;
                    }
                    
                    return note;
                };

                function getStarWidth(){
                    switch(opts.type) {
                        case 'small' :
                            starWidth = 12; // width of the picture small.png
                            starHeight = 10; // height of the picture small.png
                            bgPath = opts.smallStarsPath;
                            break;
                        default :
                            starWidth = 23; // width of the picture stars.png
                            starHeight = 20; // height of the picture stars.png
                            bgPath = opts.bigStarsPath;
                    }
                };

                function findRealLeft(obj) {
                    if( !obj ) return 0;
                    return obj.offsetLeft + findRealLeft( obj.offsetParent );
                };
            });

    };
});